import * as React from 'react';
import {
  Button,
  Table,
  Label,
  Segment,
  Header,
  Container,
} from 'semantic-ui-react';
// import { TargetTable } from '@overflow/target/react/components/TargetList';
import Probe from '@overflow/probe/api/model/Probe';
import {Discovery} from '../../../discovery/react/components/Discovery';

export interface StateProps {
  id: string;
}

export interface DispatchProps {
  // onDiscoverySelect(id:string):void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  probe: Probe;
  id: string;
  isDiscovery:boolean;
}


export class ProbeDetailInfo extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      probe: null,
      id: '44',
      isDiscovery: false,
    };
  }

  public componentWillMount(): void {
    this.setState({
      probe: null,
      id: '44',
      isDiscovery: false,
    });
  }

  public handleStartStop(event: any, data: any): void {
    console.log(event);
  }

  public handleDiscovery = (event: any, data: any): void => {
    console.log(event);
    // let probeId = String(this.state.id);
    // this.props.onDiscoverySelect(this.state.id);
    // if (this.state.isDiscovery) {
    //   this.setState({isDiscovery: false});
    // } else {
    //   this.setState({isDiscovery: true});
    // }

  }

  public showStartStopBtn(): JSX.Element {
    return <Button content='Stop' icon='stop' labelPosition='left' negative/>;
  }

  public render(): JSX.Element {
    return (
      <Container>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Domain</Header>
              </Table.Cell>
              <Table.Cell>todo</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Status</Header>
              </Table.Cell>
              <Table.Cell>todo</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Host IP</Header>
              </Table.Cell>
              <Table.Cell>todo</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Host Name</Header>
              </Table.Cell>
              <Table.Cell>todo</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Authorized at</Header>
              </Table.Cell>
              <Table.Cell>todo</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Description</Header>
              </Table.Cell>
              <Table.Cell>todo</Table.Cell>
            </Table.Row>
          </Table.Body>
          <Table.Footer>
            <Table.Row>
              <Table.HeaderCell colSpan='2'>
                {this.showStartStopBtn()}
                <Button content='Discovery' icon='search' labelPosition='left' floated={'right'} positive onClick={this.handleDiscovery}/>
              </Table.HeaderCell>
            </Table.Row>
          </Table.Footer>

        </Table>
        {/* {this.showStartStopBtn()} */}

      </Container>
    );
  }

  private showDiscovery = ():JSX.Element => {
    if (!this.state.isDiscovery) {
      this.setState({isDiscovery:true});
      return <Discovery/>;
    } else {
      this.setState({isDiscovery:false});
      return null;
    }
  }
}

